/*
 *  SimpleDrag.h     Drag Manager sample program header
 *
 *  v 1.0d2  7/93 Greg Robbins
 *
 */

	
#include <QuickDraw.h>
#include <StandardFile.h>
#include <Fonts.h>
#include <Menus.h>
#include <Dialogs.h>
#include <Events.h>
#include <TextEdit.h>
#include <OSEvents.h>
#include <Desk.h>
#include <AppleEvents.h>
#include <GestaltEqu.h>
#include <ToolUtils.h>
#include <Processes.h>
#include <Errors.h>
#include <Drag.h>
#include <Memory.h>
#include <String.h>

#ifdef THINK_C
#include <BDC.h>
#else
#include <Packages.h>
#endif
	

#include <OCE.h>
#include <OCEAuthDir.h>
#include <OCEMessaging.h>
#include <OCEErrors.h>
#include <OCEStandardMail.h>
#include <OCEStandardDirectory.h>


// function prototypes

pascal OSErr DoAEOpenApplication(AppleEvent *, AppleEvent *, long refCon);
pascal OSErr DoAEOpenDocuments(AppleEvent *, AppleEvent *, long refCon);
pascal OSErr DoAEQuitApplication(AppleEvent *, AppleEvent *, long refCon);
void DoHighLevelEvent(EventRecord *);
OSErr InstallAppleEventHandlers(void);
void DrawWindow(WindowPtr);
PicHandle GetWindowPicture(WindowPtr);
OSErr SetWindowPicture(WindowPtr, PicHandle);
OSErr SetEmptyWindowPicture(WindowPtr);
OSErr SetWindowPictureFromFile(FSSpecPtr, WindowPtr);
Boolean KeyIsDown(short);
void ConcatPascalStrings(StringPtr, StringPtr);
OSErr GetApplicationName(StringPtr);
WindowPtr OpenPictureInNewWindow(FSSpecPtr);
void DoOpen(void);
WindowPtr DoNewWindow(void);
void DoCloseWindow(WindowPtr);
void DoQuit(void);
WindowPtr DoAboutWindow(void);
WindowPtr ReportErrorInWindow(WindowPtr, StringPtr, OSErr);
WindowPtr ReportStringInWindow(WindowPtr, StringPtr);
void CreateMenus(void);
void DoMenuCommand(long);
Boolean KeyIsDown(short);
// routines to support dragging

Boolean MouseIsInContentRgn(DragReference, WindowPtr);
Boolean DragItemsAreAcceptable(DragReference);
Boolean DragIsNotInSourceWindow(DragReference);
pascal OSErr MyTrackingHandler(DragTrackingMessage, WindowPtr,
	void *, DragReference);
pascal OSErr MyReceiveHandler(WindowPtr, void *, DragReference);
OSErr InstallDragHandlers(WindowPtr theWindow);
void RemoveDragHandlers(WindowPtr);
void OutlineRegion(RgnHandle);
OSErr DoWindowContentDrag(WindowPtr, EventRecord *);


void ProcessEvents(void);

void DrawPhoneNumberAttribute(WindowPtr theWindow,
							AttributeValuePtr theAttrValue);
void DrawNoPhoneNumberAttribute(void);
OSErr GetIdentity(void);
OSErr DoAuthentication(void);

OSErr GetAttributeFromRID ( RecordIDPtr 			rid,
							short 					dsRefNum,
							const AttributeTypePtr 	attributeType,
							AttributePtr 			attributePtr,
							AuthIdentity 			identity);

OSErr DoEnumerateGet(short        dsRefNum, 
                     long         clientData,
                     RStringPtr   recordType,
					 AuthIdentity identity);
void ClearMemory(
		void				*recordPtr,
		register Size		recordSize
	);
	
OSErr OpenPersonalCatalog(
		PackedRLIPtr					rli,
		short							*dsRefNumPtr
	);

OSErr GetRecordID( FSSpecPtr     fsspec,
                   RecordIDPtr   ridPtr,
                   RStringPtr    recordType);

void myReportStringInWindow(WindowPtr theWindow,
							StringPtr theString);